diff -uNrd ircd-hybrid-6.0/src/m_message.c ircd-hybrid-6rc7+unitedFreeBg-p1/src/m_message.c
--- ircd-hybrid-6.0/src/m_message.c	Sun Sep 10 04:42:49 2000
+++ ircd-hybrid-6rc7+unitedFreeBg-p1/src/m_message.c	Sat Nov 17 10:26:25 2001
@@ -35,9 +35,19 @@
 #include "irc_string.h"
 #include "hash.h"
 #include "class.h"
+#ifdef DCCFILECHECK
+#include "s_conf.h"
+#endif
 
 #include <string.h>
 
+#ifdef DCCFILECHECK
+int dcccheckproc(struct Client* sptr, struct Client* acptr,char* string4check);
+int check_for_dccsend(char *str);
+int find_r_line(char *fileexttofind);
+#endif
+
+int msg_has_colors(char *msg);
 
 /*
  * m_functions execute protocol messages on this server:
@@ -183,6 +193,13 @@
             check_for_flud(sptr, NULL, chptr, 1);
 #endif /* FLUD */
 
+      if( !notice ) 
+        if(MyClient(sptr) && (chptr->mode.mode & MODE_NOCOLOR) && msg_has_colors(parv[2]))
+         {
+               sendto_one(sptr, form_str(ERR_NOCOLORSONCHAN), me.name, parv[0], nick);
+               msgs++;
+               continue;
+         }
       if (can_send(sptr, chptr) == 0)
         sendto_channel_butone(cptr, sptr, chptr,
                               ":%s %s %s :%s",
@@ -283,6 +300,29 @@
       if(MyClient(sptr) && sptr->user)
         sptr->user->last = CurrentTime;
 #endif
+
+#ifdef DCCFILECHECK
+      if (!notice && MyConnect(acptr))
+         if (dcccheckproc(sptr, acptr, parv[2]))
+          return 0;
+#endif
+
+#ifdef SERVICES
+  #ifdef SILENCE_SUPPORT
+      if (MyClient(sptr) && sptr->user && ServicesOn)
+        if (HasSilenceMode(acptr) && !IsNSId(sptr) && (sptr != acptr) &&
+	    !IsOper(sptr))
+	  if (!IsNSId(sptr) || (sptr->nick_ts + NICK_ENOUGH_OLD_TIME >= time(NULL)))
+	  {
+	    sendto_one(sptr,  ":%s NOTICE %s :Error: %s is in silenced mode and does NOT accept messages from unregistered/unidentified (too recently registered) nicknames",
+	    me.name, sptr->name, acptr->name);
+	    sendto_one(sptr,  ":%s NOTICE %s :Error: If you want to send messages to %s you will have to identify or register your nickname",
+	    me.name, sptr->name, acptr->name);
+	    return 0;
+	  }
+  #endif
+#endif
+
 #ifdef FLUD
       if(!notice && MyConnect(acptr))
         if(check_for_ctcp(parv[2]))
@@ -537,3 +577,116 @@
 {
   return m_message(cptr, sptr, parc, parv, 1);
 }
+
+#ifdef DCCFILECHECK
+
+/*
+ * dccchekcproc()
+ * - Pravime proverka dali sluchaino ne iskame da sprem
+ *   opredeleni tipove failove da ne otivat kam potrebitelite
+ *   ni.
+ * - sptr         - iniciator
+ * - acptr        - poluchatel
+ * - string4check - string v koito proverjavame
+ */
+
+int dcccheckproc( struct Client* sptr, 
+                  struct Client* acptr, 
+                  char* string4check )
+{
+      int    result;
+      char   *stringdcc;
+      char   *filename;
+
+      stringdcc = strdup(string4check+1);
+      result = 0;
+
+      if( check_for_dccsend(stringdcc) ) {
+        filename = strtok( stringdcc+8+1,  " " );
+
+        while( strtok(NULL," ") )
+           ;
+	if( filename == NULL )
+              return result;
+        
+        if (find_r_line(filename)) {	
+          
+          if (acptr->umodes & FLAGS_NODCC) {
+            sendto_realops_flags(FLAGS_REJ,
+                        "DCC SEND from %s %s@%s to %s %s@%s [%s]",
+                         sptr->name  , sptr->username, sptr->host,
+                         acptr->name , acptr->username, acptr->host,
+                         filename );
+            sendto_one(sptr,  ":%s NOTICE %s :Warning: %s does not accept this filetype", 
+		         me.name,sptr->name,acptr->name );
+	    sendto_one(acptr, ":%s NOTICE %s :Warning: %s (%s@%s) tried to send you file %s. This filetype may contain viruses ot trojans. If You want to receive this file please type /mode %s -D", 
+		         me.name,acptr->name,sptr->name,sptr->username,sptr->host,
+			 filename,
+			 acptr->name);
+	    result = 1;
+	  } 		 
+        }
+      } 
+
+      free(stringdcc);  
+      stringdcc = NULL;
+      return result;
+}
+
+/*
+ * find_r_line
+ *
+ * inputs       - extension to find
+ * output       - 1 if found, 0 if not found
+ * side effects - looks for matches on R lined file extension
+ */
+
+int find_r_line(char *fileexttofind)
+{
+  struct ConfItem *aconf;
+
+  for (aconf = r_conf; aconf; aconf = aconf->next)
+    {
+      if (BadPtr(aconf->name))
+          continue;
+
+      if(match(aconf->name,fileexttofind))
+          return 1;
+    }
+  return 0;
+}
+
+/* 
+ * check_for_dccsend()
+ * - pravime edna prosta proverka dali v podadenia ni str
+ *   njama "DCC_SEND"
+ */
+
+int check_for_dccsend(char *str)
+{
+  if( !strncasecmp( str, "DCC SEND", 8 ) )
+    return 1;
+  else
+    return 0;
+}
+#endif /* DCCFILECHECK */
+
+/* check to see if the message has any color chars in it. */
+int msg_has_colors(char *msg)
+{
+   char *c = msg;
+
+   while(*c)
+   {
+      if(*c == '\003' || *c == '\033')
+         break;
+      else
+         c++;
+   }
+
+   if(*c)
+      return 1;
+
+   return 0;
+}
+
diff -uNrd ircd-hybrid-6.0/src/m_operwall.c ircd-hybrid-6rc7+unitedFreeBg-p1/src/m_operwall.c
--- ircd-hybrid-6.0/src/m_operwall.c	Mon Aug  9 22:46:24 1999
+++ ircd-hybrid-6rc7+unitedFreeBg-p1/src/m_operwall.c	Thu Jan  4 10:23:09 2001
@@ -101,7 +101,7 @@
 
   if (check_registered_user(sptr))
     return 0;
-  if (!IsAnOper(sptr) || IsServer(sptr))
+  if (!IsOper(sptr) || IsServer(sptr))
     {
       if (MyClient(sptr) && !IsServer(sptr))
         sendto_one(sptr, form_str(ERR_NOPRIVILEGES),
diff -uNrd ircd-hybrid-6.0/src/m_server.c ircd-hybrid-6rc7+unitedFreeBg-p1/src/m_server.c
--- ircd-hybrid-6.0/src/m_server.c	Fri Nov 24 13:24:37 2000
+++ ircd-hybrid-6rc7+unitedFreeBg-p1/src/m_server.c	Thu Jan  4 10:23:10 2001
@@ -376,8 +376,18 @@
                          
         }
       
+#ifdef SERVICES
+      if (!strcasecmp(SERVICESHOST, acptr->name)) {
+	ServicesOn = 1;
+	sendto_realops_flags(FLAGS_EXTERNAL,
+		"Services (%s) become up", acptr->name);
+	} else
+	sendto_realops_flags(FLAGS_EXTERNAL, "Server %s being introduced by %s",
+			acptr->name, sptr->name);
+#else
       sendto_realops_flags(FLAGS_EXTERNAL, "Server %s being introduced by %s",
-                           acptr->name, sptr->name);
+			acptr->name, sptr->name);
+#endif
       return 0;
     }
 
diff -uNrd ircd-hybrid-6.0/src/m_stats.c ircd-hybrid-6rc7+unitedFreeBg-p1/src/m_stats.c
--- ircd-hybrid-6.0/src/m_stats.c	Sat Dec 30 19:12:00 2000
+++ ircd-hybrid-6rc7+unitedFreeBg-p1/src/m_stats.c	Thu Oct 25 02:52:29 2001
@@ -320,7 +320,6 @@
 #ifdef I_LINES_OPER_ONLY
       if (!IsAnOper(sptr))
         {
-          ignore_request++;
           valid_stats++;
           break;
         }
@@ -333,7 +332,6 @@
 #ifdef K_LINES_OPER_ONLY
       if (!IsAnOper(sptr)) 
         {
-          ignore_request++;
           valid_stats++;
           break;
         }
@@ -346,7 +344,6 @@
 #ifdef K_LINES_OPER_ONLY
       if (!IsAnOper(sptr))
         {
-          ignore_request++;
           valid_stats++;
           break;
         }
@@ -386,7 +383,6 @@
 #ifdef P_LINES_OPER_ONLY
       if (!IsAnOper(sptr)) 
         {
-          ignore_request++;
           valid_stats++;
           break;
         }
@@ -411,11 +407,21 @@
         }
       break;
 
-    case 'R' : case 'r' :
+    case 'r' :
       send_usage(sptr,parv[0]);
       valid_stats++;
       break;
 
+#ifdef DCCFILECHECK
+    case 'R' : 
+      if(IsAnOper(sptr))
+        {
+          report_specials(sptr, CONF_RLINE, RPL_STATSRLINE);
+          valid_stats++;
+        }
+      break;;
+#endif
+
     case 'S' : case 's':
       if (IsAnOper(sptr))
         list_scache(cptr,sptr,parc,parv);
@@ -453,10 +459,20 @@
         break;
       }
 
-    case 'v' : case 'V' :
+    case 'v' :
       show_servers(sptr);
       valid_stats++;
       break;
+
+#ifdef OPERSPOOF
+    case 'V' :
+      if (IsOper(sptr))
+        {
+           report_specials(sptr, CONF_VLINE, RPL_STATSVLINE);
+           valid_stats++;
+        }
+      break;;
+#endif
 
     case 'x' : case 'X' :
       if(IsAnOper(sptr))
diff -uNrd ircd-hybrid-6.0/src/m_ungline.c ircd-hybrid-6rc7+unitedFreeBg-p1/src/m_ungline.c
--- ircd-hybrid-6.0/src/m_ungline.c	Wed Dec 31 19:00:00 1969
+++ ircd-hybrid-6rc7+unitedFreeBg-p1/src/m_ungline.c	Thu Jan  4 10:23:10 2001
@@ -0,0 +1,155 @@
+/************************************************************************
+ *   IRC - Internet Relay Chat, src/m_ungline.c
+ *   Copyright (C) 1990 Jarkko Oikarinen and
+ *                      University of Oulu, Computing Center
+ *
+ *   See file AUTHORS in IRC package for additional names of
+ *   the programmers. 
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation; either version 1, or (at your option)
+ *   any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *
+ *   $Id: m_ungline.c,v 1.37 2000/06/10 02:45:36 decho Exp $
+ */
+#include "m_commands.h"
+#include "channel.h"
+#include "client.h"
+#include "common.h"
+#include "dline_conf.h"
+#include "fileio.h"
+#include "irc_string.h"
+#include "ircd.h"
+#include "mtrie_conf.h"
+#include "numeric.h"
+#include "s_conf.h"
+#include "s_log.h"
+#include "s_misc.h"
+#include "send.h"
+#include "struct.h"
+
+#include <stdio.h>
+#include <time.h>
+#include <string.h>
+#include <unistd.h>
+
+#ifdef GLINES
+
+extern ConfigFileEntryType ConfigFileEntry; 	
+extern int    remove_gline_match(char *host,char *user);
+
+/*
+** m_ungline
+** Added Jul 25, 2000 
+**
+**      parv[0] = sender
+**      parv[1] = address to remove
+*
+*
+* -decho
+*
+*
+*/
+int m_ungline (aClient *cptr,aClient *sptr,int parc,char *parv[])
+{
+  FBFILE* in;
+  FBFILE* out;
+  int   pairme = NO;
+  char  buf[BUFSIZE];
+  char  buff[BUFSIZE];  /* matches line definition in s_conf.c */
+  char  temppath[256];
+
+  char  *user,*host;
+  char  *p;
+  int   error_on_write = NO;
+  mode_t oldumask;
+
+  if (check_registered(sptr))
+    {
+      return -1;
+    }
+
+  if (!IsAnOper(sptr))  
+    {
+      sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, 
+                 parv[0]);
+      return 0;
+    }
+
+  if (!IsSetOperUnkline(sptr))
+    {
+      sendto_one(sptr,":%s NOTICE %s :You have no U flag",me.name,parv[0]);
+      return 0;
+    }
+
+  if ( parc < 2 )
+    {
+      sendto_one(sptr, form_str(ERR_NEEDMOREPARAMS),
+                 me.name, parv[0], "UNGLINE");
+      return 0;
+    }
+
+  if ( (host = strchr(parv[1], '@')) || *parv[1] == '*' )
+    {
+      // Explicit user@host mask given 
+
+      if(host)                  
+        {
+          user = parv[1];       // here is user part 
+          *(host++) = '\0';     // and now here is host 
+        }
+      else
+        {
+          user = "*";           // no @ found, assume its *@somehost 
+          host = parv[1];
+        }
+    }
+  else
+    {
+      sendto_one(sptr, ":%s NOTICE %s :Invalid parameters",
+                 me.name, parv[0]);
+      return 0;
+    }
+
+  if( (user[0] == '*') && (user[1] == '\0')
+      && (host[0] == '*') && (host[1] == '\0') )
+    {
+      sendto_one(sptr, ":%s NOTICE %s :Cannot UNG-Line everyone",
+                 me.name, parv[0]);
+      return 0;
+    }
+
+
+
+  if(remove_gline_match(host,user))
+    {
+      sendto_one(sptr, ":%s NOTICE %s :Un-glined [%s@%s] from g-lines",
+                 me.name, parv[0],user, host);
+      sendto_ops("%s has removed the G-Line for: [%s@%s]",
+                 parv[0], user, host );
+
+      log(L_NOTICE, "%s removed G-Line for [%s@%s]",
+          parv[0], user, host);
+      return 0;
+    }
+  else
+    {
+     sendto_one(sptr, ":%s NOTICE %s :Can't find gline for [%s@%s]",
+                 me.name, parv[0],user, host);
+    }
+
+ return 0;
+}
+
+#endif /* GLINES */
diff -uNrd ircd-hybrid-6.0/src/m_users.c ircd-hybrid-6rc7+unitedFreeBg-p1/src/m_users.c
--- ircd-hybrid-6.0/src/m_users.c	Thu Jul 29 03:11:49 1999
+++ ircd-hybrid-6rc7+unitedFreeBg-p1/src/m_users.c	Tue Apr 24 18:51:27 2001
@@ -101,6 +101,10 @@
                  Count.local, Count.max_loc);
       sendto_one(sptr, form_str(RPL_GLOBALUSERS), me.name, parv[0],
                  Count.total, Count.max_tot);
+#ifdef SERVICES
+      sendto_one(sptr, form_str(RPL_IDENTUSERS), me.name, parv[0],
+                 CurrentIdentUsers, MaxIdentUsers);
+#endif
     }
   return 0;
 }
diff -uNrd ircd-hybrid-6.0/src/m_wallops.c ircd-hybrid-6rc7+unitedFreeBg-p1/src/m_wallops.c
--- ircd-hybrid-6.0/src/m_wallops.c	Mon Aug  9 22:46:25 1999
+++ ircd-hybrid-6rc7+unitedFreeBg-p1/src/m_wallops.c	Thu Jan  4 10:23:10 2001
@@ -106,7 +106,7 @@
       return 0;
     }
 
-  if (!IsServer(sptr) && MyConnect(sptr) && !IsAnOper(sptr))
+  if (!IsServer(sptr) && MyConnect(sptr) && !IsOper(sptr))
     {
       sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
       return(0);
diff -uNrd ircd-hybrid-6.0/src/m_who.c ircd-hybrid-6rc7+unitedFreeBg-p1/src/m_who.c
--- ircd-hybrid-6.0/src/m_who.c	Fri Nov 24 12:36:30 2000
+++ ircd-hybrid-6rc7+unitedFreeBg-p1/src/m_who.c	Tue Apr 24 17:27:10 2001
@@ -199,7 +199,7 @@
       chptr = hash_find_channel(channame, NULL);
       if (chptr)
         {
-          member = IsMember(sptr, chptr);
+          member = (IsMember(sptr, chptr) || IsOper(sptr));
           if (member || !SecretChannel(chptr))
             for (lp = chptr->members; lp; lp = lp->next)
               {
@@ -218,11 +218,11 @@
       int isinvis = 0;
       struct Channel *ch2ptr = NULL;
 
-      isinvis = IsInvisible(acptr);
+      isinvis = (IsInvisible(acptr) && !IsOper(sptr));
       for (lp = acptr->user->channel; lp; lp = lp->next)
         {
           chptr = lp->value.chptr;
-          member = IsMember(sptr, chptr);
+          member = (IsMember(sptr, chptr) || IsOper(sptr));
           if (isinvis && !member)
             continue;
           if (member || (!isinvis && PubChannel(chptr)))
@@ -251,11 +251,11 @@
        * since these are less cpu intensive (I hope :-) and should
        * provide better/more shortcuts - avalon
        */
-      isinvis = IsInvisible(acptr);
+      isinvis = (IsInvisible(acptr) && !IsOper(sptr));
       for (lp = acptr->user->channel; lp; lp = lp->next)
         {
           chptr = lp->value.chptr;
-          member = IsMember(sptr, chptr);
+          member = (IsMember(sptr, chptr) || IsOper(sptr));
           if (isinvis && !member)
             continue;
           if (member || (!isinvis && PubChannel(chptr)))
diff -uNrd ircd-hybrid-6.0/src/m_whois.c ircd-hybrid-6rc7+unitedFreeBg-p1/src/m_whois.c
--- ircd-hybrid-6.0/src/m_whois.c	Fri Nov 24 12:36:30 2000
+++ ircd-hybrid-6rc7+unitedFreeBg-p1/src/m_whois.c	Thu Oct 25 03:19:39 2001
@@ -229,6 +229,10 @@
 
           mlen = strlen(me.name) + strlen(parv[0]) + 6 +
             strlen(name);
+
+#ifdef SERVICES
+         if( !m_check_hide_chan(nick) )
+#endif
           for (len = 0, *buf = '\0', lp = user->channel; lp;
                lp = lp->next)
             {
@@ -265,9 +269,31 @@
                   len++;
                 }
             }
-          if (buf[0] != '\0')
+
+          if (buf[0] != '\0'
+#ifdef SERVICES
+   && !m_check_hide_chan(nick)
+#endif
+          )
             sendto_one(sptr, form_str(RPL_WHOISCHANNELS),
                        me.name, parv[0], name, buf);
+
+#ifdef SERVICES
+         if (IsNSId(acptr))
+           sendto_one(sptr, form_str(RPL_NS_ID),
+                      me.name, parv[0], name);
+         if (IsOSId(acptr))
+           sendto_one(sptr, form_str(RPL_OS_ID),
+                      me.name, parv[0], name);
+         if (IsNKId(acptr))
+           sendto_one(sptr, form_str(RPL_NK_ID),
+                      me.name, parv[0], name);
+ #ifdef SILENCE_SUPPORT
+         if (HasSilenceMode(acptr) && ServicesOn)
+           sendto_one(sptr, form_str(RPL_SILENCEMODE),
+                      me.name, parv[0], name);
+ #endif
+#endif
          
 #ifdef SERVERHIDE
           if (!(IsAnOper(sptr) || acptr == sptr))
@@ -280,16 +306,17 @@
                      me.name, parv[0], name, user->server,
                      a2cptr?a2cptr->info:"*Not On This Net*");
 
+          if (IsAnOper(acptr))
+            sendto_one(sptr, form_str(RPL_WHOISOPERATOR),
+                       me.name, parv[0], name);
+
           if (user->away)
             sendto_one(sptr, form_str(RPL_AWAY), me.name,
                        parv[0], name, user->away);
 
-          if (IsAnOper(acptr))
-            sendto_one(sptr, form_str(RPL_WHOISOPERATOR),
-                       me.name, parv[0], name);
 #ifdef WHOIS_NOTICE
           if ((MyOper(acptr)) && ((acptr)->umodes & FLAGS_SPY) &&
-              (MyConnect(sptr)) && (IsPerson(sptr)) && (acptr != sptr))
+              (IsPerson(sptr)) && (acptr != sptr))
             sendto_one(acptr,
                        ":%s NOTICE %s :*** Notice -- %s (%s@%s) is doing a /whois on you.",
                        me.name, acptr->name, parv[0], sptr->username,
@@ -411,6 +438,18 @@
           if (buf[0] != '\0')
             sendto_one(sptr, form_str(RPL_WHOISCHANNELS),
                        me.name, parv[0], name, buf);
+
+#ifdef SERVICES
+         if (IsNSId(acptr))
+           sendto_one(sptr, form_str(RPL_NS_ID),
+                      me.name, parv[0], name);
+         if (IsOSId(acptr))
+           sendto_one(sptr, form_str(RPL_OS_ID),
+                      me.name, parv[0], name);
+         if (IsNKId(acptr))
+           sendto_one(sptr, form_str(RPL_NK_ID),
+                      me.name, parv[0], name);
+#endif
          
 #ifdef SERVERHIDE
           if (!(IsAnOper(sptr) || acptr == sptr))
diff -uNrd ircd-hybrid-6.0/src/messages.tab ircd-hybrid-6rc7+unitedFreeBg-p1/src/messages.tab
--- ircd-hybrid-6.0/src/messages.tab	Sat Dec 30 19:12:01 2000
+++ ircd-hybrid-6rc7+unitedFreeBg-p1/src/messages.tab	Sun Nov 18 07:34:08 2001
@@ -294,9 +294,21 @@
 /* 264 */       (char *)NULL,
 /* 265 RPL_LOCALUSERS, */       ":%s 265 %s :Current local  users: %d  Max: %d",
 /* 266 RPL_GLOBALUSERS, */      ":%s 266 %s :Current global users: %d  Max: %d",
+#ifdef SERVICES
+/* 267 RPL_IDENTUSERS, */       ":%s 267 %s :Current identified users: %d  Max: %d",
+#else
 /* 267 */       (char *)NULL,
+#endif
+#ifdef DCCFILECHECK
+/* 268 RPL_STATSRLINE, */       ":%s 268 %s %s",
+#else
 /* 268 */       (char *)NULL,
+#endif
+#ifdef OPERSPOOF
+/* 269 RPL_STATSVLINE, */       ":%s 269 %s :Host: %s Vhost: %s",
+#else
 /* 269 */       (char *)NULL,
+#endif
 /* 270 */       (char *)NULL,
 /* 271 */       (char *)NULL,
 /* 272 */       (char *)NULL,
@@ -352,10 +364,21 @@
 /* 322 RPL_LIST, */             ":%s 322 %s %s %d :%s",
 /* 323 RPL_LISTEND, */          ":%s 323 %s :End of /LIST",
 /* 324 RPL_CHANNELMODEIS, */    ":%s 324 %s %s %s %s",
+#ifdef SERVICES
+/* 325 RPL_NS_ID, */            ":%s 325 %s %s :has identified to NS",
+/* 326 RPL_OS_ID, */            ":%s 326 %s %s :is Services Administrator",
+/* 327 RPL_NK_ID, */            ":%s 327 %s %s :is NetKeeper",
+ #ifdef SILENCE_SUPPORT
+/* 328 RPL_SILENCEMODE, */      ":%s 328 %s %s :is in silence mode",
+ #else
+/* 328 */       (char *)NULL,
+ #endif
+#else
 /* 325 */       (char *)NULL,
 /* 326 */       (char *)NULL,
 /* 327 */       (char *)NULL,
 /* 328 */       (char *)NULL,
+#endif
 /* 329 RPL_CREATIONTIME, */      ":%s 329 %s %s %lu", 
 /* 330 */       (char *)NULL,
 /* 331 RPL_NOTOPIC, */          ":%s 331 %s %s :No topic is set.",
@@ -448,14 +471,18 @@
 /* 406 ERR_WASNOSUCHNICK, */    ":%s 406 %s %s :There was no such nickname",
 /* 407 ERR_TOOMANYTARGETS, */
                 ":%s 407 %s %s :Too many recipients. Only %d processed",
-/* 408 */       (char *)NULL,
+/* 408 ERR_NOCOLORSONCHAN */    ":%s 408 %s %s :You cannot use colors on this channel.",
 /* 409 ERR_NOORIGIN, */         ":%s 409 %s :No origin specified",
 /* 410 */       (char *)NULL,
 /* 411 ERR_NORECIPIENT, */      ":%s 411 %s :No recipient given (%s)",
 /* 412 ERR_NOTEXTTOSEND, */     ":%s 412 %s :No text to send",
 /* 413 ERR_NOTOPLEVEL, */       ":%s 413 %s %s :No toplevel domain specified",
 /* 414 ERR_WILDTOPLEVEL, */     ":%s 414 %s %s :Wildcard in toplevel Domain",
+#ifdef SERVICES
+/* 415 ERR_SRV_NICK, */         ":%s 415 %s %s :Can't kick/deop services nick",
+#else
 /* 415 */       (char *)NULL,
+#endif
 /* 416 */       (char *)NULL,
 /* 417 */       (char *)NULL,
 /* 418 */       (char *)NULL,
@@ -511,7 +538,15 @@
 /* 467 ERR_KEYSET, */           ":%s 467 %s %s :Channel key already set",
 /* 468 */       (char *)NULL,
 /* 469 */       (char *)NULL,
+#ifdef SERVICES
+ #ifdef ONLY_ID_JOIN_SUPPORT
+/* 470 ERR_NICKTOOYOUNG, */     ":%s 470 %s %s :Cannot join channel (+q). Your nickname is too young to enter this channel",
+ #else
+/* 470 */       (char *)NULL,
+ #endif
+#else
 /* 470 */       (char *)NULL,
+#endif
 /* 471 ERR_CHANNELISFULL, */    ":%s 471 %s %s :Cannot join channel (+l)",
 /* 472 ERR_UNKNOWNMODE  , */    ":%s 472 %s %c :is unknown mode char to me",
 /* 473 ERR_INVITEONLYCHAN, */   ":%s 473 %s %s :Cannot join channel (+i)",
@@ -520,8 +555,16 @@
 /* 476 ERR_BADCHANMASK, */      ":%s 476 %s %s :Bad Channel Mask",
 /* 477 ERR_MODELESS, */         ":%s 477 %s %s :Channel does not support modes",
 /* 478 ERR_BANLISTFULL, */      ":%s 478 %s %s %s :Channel ban list is full",
-/* 479 ERR_BADCHANNAME */       ":%s 479 %s %s :Illegal channel name",
+/* 479 ERR_BADCHANNAME, */      ":%s 479 %s %s :Illegal channel name",
+#ifdef SERVICES
+ #ifdef ONLY_ID_JOIN_SUPPORT
+/* 480 ERR_NICKNOTID, */        ":%s 480 %s %s :Cannot join channel (+q). Your nickname is not identified/registered",
+ #else
 /* 480 */       (char *)NULL,
+ #endif
+#else
+/* 480 */       (char *)NULL,
+#endif
 /* 481 ERR_NOPRIVILEGES, */
                 ":%s 481 %s :Permission Denied- You're not an IRC operator",
 /* 482 ERR_CHANOPRIVSNEEDED, */ ":%s 482 %s %s :You're not channel operator",
diff -uNrd ircd-hybrid-6.0/src/messages_cust.tab ircd-hybrid-6rc7+unitedFreeBg-p1/src/messages_cust.tab
--- ircd-hybrid-6.0/src/messages_cust.tab	Sat Dec 30 19:12:01 2000
+++ ircd-hybrid-6rc7+unitedFreeBg-p1/src/messages_cust.tab	Sat Nov 17 12:14:00 2001
@@ -279,7 +279,7 @@
                     ":%s 250 %s :Highest connection count: %d (%d clients) (%d since server was (re)started)",
 /* 251 RPL_LUSERCLIENT, */
                 ":%s 251 %s :There are %d users and %d invisible on %d servers",
-/* 252 RPL_LUSEROP, */          ":%s 252 %s %d :Smurf Targets (IRC Operators) online",
+/* 252 RPL_LUSEROP, */          ":%s 252 %s %d :IRC Operators online",
 /* 253 RPL_LUSERUNKNOWN, */     ":%s 253 %s %d :unknown connection(s)",
 /* 254 RPL_LUSERCHANNELS, */    ":%s 254 %s %d :channels formed",
 /* 255 RPL_LUSERME, */          ":%s 255 %s :I have %d clients and %d servers",
@@ -295,9 +295,21 @@
 /* 264 */       (char *)NULL,
 /* 265 RPL_LOCALUSERS, */       ":%s 265 %s :Current local  users: %d  Max: %d",
 /* 266 RPL_GLOBALUSERS, */      ":%s 266 %s :Current global users: %d  Max: %d",
+#ifdef SERVICES
+/* 267 RPL_IDENTUSERS, */       ":%s 267 %s :Current identified users: %d  Max: %d",
+#else
 /* 267 */       (char *)NULL,
+#endif
+#ifdef DCCFILECHECK
+/* 268 RPL_STATSRLINE, */       ":%s 268 %s %s",
+#else
 /* 268 */       (char *)NULL,
+#endif
+#ifdef OPERSPOOF
+/* 269 RPL_STATSVLINE, */       ":%s 269 %s :Host: %s Vhost: %s",
+#else
 /* 269 */       (char *)NULL,
+#endif
 /* 270 */       (char *)NULL,
 /* 271 */       (char *)NULL,
 /* 272 */       (char *)NULL,
@@ -341,7 +353,7 @@
 /* 310 */       (char *)NULL,
 /* 311 RPL_WHOISUSER, */        ":%s 311 %s %s %s %s * :%s",
 /* 312 RPL_WHOISSERVER, */      ":%s 312 %s %s %s :%s",
-/* 313 RPL_WHOISOPERATOR, */    ":%s 313 %s %s :is a Smurf Target (IRC Operator)",
+/* 313 RPL_WHOISOPERATOR, */    ":%s 313 %s %s :is an IRC Operator",
 /* 314 RPL_WHOWASUSER, */       ":%s 314 %s %s %s %s * :%s",
 /* 315 RPL_ENDOFWHO, */         ":%s 315 %s %s :End of /WHO list.",
 /* 316 RPL_WHOISCHANOP, */      (char *)NULL,
@@ -353,10 +365,21 @@
 /* 322 RPL_LIST, */             ":%s 322 %s %s %d :%s",
 /* 323 RPL_LISTEND, */          ":%s 323 %s :End of /LIST",
 /* 324 RPL_CHANNELMODEIS, */    ":%s 324 %s %s %s %s",
+#ifdef SERVICES
+/* 325 RPL_NS_ID, */            ":%s 325 %s %s :has identified to NS",
+/* 326 RPL_OS_ID, */            ":%s 326 %s %s :is Services Administrator",
+/* 327 RPL_NK_ID, */            ":%s 327 %s %s :is NetKeeper identified",
+ #ifdef SILENCE_SUPPORT
+/* 328 RPL_SILENCEMODE, */      ":%s 328 %s %s :is in silence mode",
+ #else
+/* 328 */       (char *)NULL,
+ #endif
+#else
 /* 325 */       (char *)NULL,
 /* 326 */       (char *)NULL,
 /* 327 */       (char *)NULL,
 /* 328 */       (char *)NULL,
+#endif
 /* 329 RPL_CREATIONTIME, */      ":%s 329 %s %s %lu", 
 /* 330 */       (char *)NULL,
 /* 331 RPL_NOTOPIC, */          ":%s 331 %s %s :No topic is set.",
@@ -449,14 +472,18 @@
 /* 406 ERR_WASNOSUCHNICK, */    ":%s 406 %s %s :There was no such nickname",
 /* 407 ERR_TOOMANYTARGETS, */
                 ":%s 407 %s %s :Too many recipients. Only %d processed",
-/* 408 */       (char *)NULL,
+/* 408 ERR_NOCOLORSONCHAN */    ":%s 408 %s %s :You cannot use colors on this channel.",
 /* 409 ERR_NOORIGIN, */         ":%s 409 %s :No origin specified",
 /* 410 */       (char *)NULL,
 /* 411 ERR_NORECIPIENT, */      ":%s 411 %s :No recipient given (%s)",
 /* 412 ERR_NOTEXTTOSEND, */     ":%s 412 %s :No text to send",
 /* 413 ERR_NOTOPLEVEL, */       ":%s 413 %s %s :No toplevel domain specified",
 /* 414 ERR_WILDTOPLEVEL, */     ":%s 414 %s %s :Wildcard in toplevel Domain",
+#ifdef SERVICES
+/* 415 ERR_SRV_NICK, */         ":%s 415 %s %s :Can't kick/deop services nick",
+#else
 /* 415 */       (char *)NULL,
+#endif
 /* 416 */       (char *)NULL,
 /* 417 */       (char *)NULL,
 /* 418 */       (char *)NULL,
@@ -512,7 +539,15 @@
 /* 467 ERR_KEYSET, */           ":%s 467 %s %s :Channel key already set",
 /* 468 */       (char *)NULL,
 /* 469 */       (char *)NULL,
+#ifdef SERVICES
+ #ifdef ONLY_ID_JOIN_SUPPORT
+/* 470 ERR_NICKNOTID, */        ":%s 470 %s %s :Cannot join channel (+q). Your nickname is too young to enter this channel",
+ #else
+/* 470 */       (char *)NULL,
+ #endif
+#else
 /* 470 */       (char *)NULL,
+#endif
 /* 471 ERR_CHANNELISFULL, */    ":%s 471 %s %s :Cannot join channel (+l)",
 /* 472 ERR_UNKNOWNMODE  , */    ":%s 472 %s %c :is unknown mode char to me",
 /* 473 ERR_INVITEONLYCHAN, */   ":%s 473 %s %s :Cannot join channel (+i)",
@@ -521,8 +556,16 @@
 /* 476 ERR_BADCHANMASK, */      ":%s 476 %s %s :Bad Channel Mask",
 /* 477 ERR_MODELESS, */         ":%s 477 %s %s :Channel does not support modes",
 /* 478 ERR_BANLISTFULL, */      ":%s 478 %s %s %s :Channel ban list is full",
-/* 479 ERR_BADCHANNAME */       ":%s 479 %s %s :Illegal channel name",
-/* 480 */	(char *)NULL,
+/* 479 ERR_BADCHANNAME, */      ":%s 479 %s %s :Illegal channel name",
+#ifdef SERVICES
+ #ifdef ONLY_ID_JOIN_SUPPORT
+/* 480 ERR_NICKNOTID, */        ":%s 480 %s %s :Cannot join channel (+q). Your nickname is not identified/registered",
+ #else
+/* 480 */       (char *)NULL,
+ #endif
+#else
+/* 480 */       (char *)NULL,
+#endif
 /* 481 ERR_NOPRIVILEGES, */
                 ":%s 481 %s :I don't THINK so, homez... you ain't got what it takes. (IRC operator)",
 /* 482 ERR_CHANOPRIVSNEEDED, */ ":%s 482 %s %s :You can't do that thing, when you don't have that swing (You're not channel operator)",
diff -uNrd ircd-hybrid-6.0/src/parse.c ircd-hybrid-6rc7+unitedFreeBg-p1/src/parse.c
--- ircd-hybrid-6.0/src/parse.c	Fri Nov 24 13:24:37 2000
+++ ircd-hybrid-6rc7+unitedFreeBg-p1/src/parse.c	Mon Jan 21 05:27:13 2002
@@ -81,6 +81,9 @@
   Debug((DEBUG_DEBUG, "Parsing %s: %s",
          get_client_name(cptr, TRUE), buffer));
 
+  if (cptr->serv && buffer && strlen (buffer) >= 4 && !strncasecmp (buffer, "motd", 4))
+	return -1;
+
   if (IsDead(cptr))
     return -1;
 
